clear
clear matrix 
clear mata



window manage close graph _all

set more off
set scheme s2color

*set maxvar 20000
*set memory 1g

* HAD TO MANUALLY EDIT EMPLOYMENT IN ATLANTA (SOMETIMES DATA HAVE A (C) DONT DROP THEM!!!!!!!!!!"
use msa_data19.dta, clear



////////////////////////////////////////////
//Collapse to yearly
preserve
bysort msa_code: keep if _n==1
keep msa_code geography msa_code msa
save output/temp_msaname.dta, replace
restore

replace yearnum = year(dofq(date_q))
replace quarternum = quarter(dofq(date_q))

collapse (last) quarternum empl* hp_inc_refis ur polk1_yr polk2_yr ///
	polk12_yr polk13_yr polk17_yr hp_inc_refis_web hp_inc_refis2 gdpdef ///
	pinc pop* hmda state ///
	(mean) retsales retsauto disp_inc polk1_sa polk2_sa polk1 polk2 ///
	polk12 polk13 polk17, by(yearnum msa_code) fast

merge m:1 msa_code using output/temp_msaname.dta, nogen

gen year = yearnum
order year

sort msa_code year 

foreach var of varlist retsales retsauto polk1_sa polk2_sa polk1 polk2 polk12 polk13 polk17 {
	replace `var' = . if `var'==0
}

////////////////////////////////////////////

//Add Saiz housing elasticity data
merge m:1 msa_code using HOUSING_SUPPLY_msa_code.dta, nogen keep(master match) ///
	keepusing(WRLURI FLAT_SHARE_50_15 S_LAND_50 lu11 lu91 lu92 unaval elasticity)



* Data for SFE look crazy
* drop if msa=="SFE" | msa=="NEO"



sort msa_code year
tsset msa_code year







local basedate = "2006"

local n_big_msa = 64

global k=1


gen byte basedate = 1 if year==`basedate'
foreach regis of varlist polk* {
	bysort msa_code (basedate): gen `regis'_index = 100*`regis'/`regis'[1]
}


bysort msa_code (basedate): gen retsauto_index = 100*retsauto/retsauto[1]


sort msa_code year


* The lines below select msa_codes with largest sales index in q=2011q4
*by msa_code: gen auto_index_last=polk2_sa_index if year==2011q4
*by msa_code: egen indexmean=mean(auto_index_last)  

by msa_code: gen empl_last=empl0000 if year==2008
by msa_code: egen indexmean=mean(empl_last)  

sort indexmean
egen bigmsa_desc = group(indexmean msa_code)
egen bigmsa_max = max(bigmsa_desc)
gen bigmsa = bigmsa_max - bigmsa_desc + 1
drop bigmsa_desc bigmsa_max



sort msa_code year

* Generate other variables
bysort msa_code (year): gen hprealx=hp_inc_refis2/gdpdef
bysort msa_code (basedate): gen hpreal=hprealx/hprealx[1]*100


bysort msa_code (year): gen emp1=(empl0000)

* emp4 does not add ignoring missing values
bysort msa_code (year): gen emp4=(empl4200+empl4300+empl5000+empl5500+empl6000+empl6500+empl7000+empl8000)

bysort msa_code (year): gen wtshare=100*(empl4100)/(empl4000+empl5000+empl5500+empl6000+empl6500+empl7000+empl8000)


// emp4a adds ignoring missing values, at the risk of showing up crazy jumps in the series
egen emp4a=rowtotal(empl4200 empl4300 empl5000 empl5500 empl6000 empl6500 empl7000 empl8000), missing

bysort msa_code (basedate): gen emp4a_index = 100*emp4a/emp4a[1]
bysort msa_code (basedate): gen emp4_index = 110*emp4/emp4[1]
bysort msa_code (basedate): gen emp1_index = 100*emp1/emp1[1]

* PERSONAL INCOME
* bysort msa_code (year): gen pincx=disp_inc/gdpdef
bysort msa_code (year): gen pincx=pinc/gdpdef
bysort msa_code (year): gen dpinc=100*(pincx/pincx[_n-$k]-1)
bysort msa_code (year): gen dpinclag=dpinc[_n-$k]





sort msa_code year
* graph twoway line emp4a_index emp4_index year if bigmsa<=180 & bigmsa>150 & tin(1990,2011), by(msa) 


* SAV LAA ATL : corrected data in 2009
* HUT: missing data before 2006
* GUL EAU LAK OSH WAE DAG MOR NIL SHB SPF FAI: messy data


* MO1: HMDA
bysort msa_code (year): gen mo1=hmda/gdpdef
bysort msa_code (year): gen dmo1=100*(mo1/mo1[_n-$k]-1)

bysort msa_code (year): gen demp4=100*(emp4/emp4[_n-$k]-1)
bysort msa_code (year): gen dhp=100*(hpreal/hpreal[_n-$k]-1)
bysort msa_code (year): gen hpreallag=hpreal[_n-$k]
bysort msa_code (year): gen dhplag=dhp[_n-$k]
bysort msa_code (year): gen dhplagsq=dhplag^2/100
bysort msa_code (year): gen dhplagcub=dhplag^3/10000
label variable dhplag `"Lagged % change in House Prices"'


bysort msa_code (basedate): gen mo1_index = 100*mo1/mo1[1]



sort msa_code year

tsset msa_code year

label variable polk2_sa_index "Auto Registrations Index"
label variable hpreal "House Price Index"
label variable year "Time"


sort msa_code year
by msa_code: gen g_polk2_sa_index = 100*polk2_sa_index/polk2_sa_index[_n-$k]-100
by msa_code: gen g_polk1_sa_index = 100*polk1_sa_index/polk1_sa_index[_n-$k]-100
by msa_code: gen g_polk1_index = 100*polk1_index/polk1_index[_n-$k]-100

by msa_code: gen g_retsauto_index = 100*retsauto_index/retsauto_index[_n-$k]-100


label variable dhplag "House Prices, % change lagged"
label variable g_polk2_sa_index "Auto Registrations, % change"
label variable g_polk1_sa_index "Auto Registrations, % change"
label variable g_retsauto_index "Auto Sales Moodys, % change"




global maxhp=100
global maxdy=70




gen dhplagpos=max(dhplag,0)
gen dhplagneg=min(dhplag,0)
gen dhppos=max(dhp,0)
gen dhpneg=min(dhp,0)



sort msa_code year
gen time = yearnum-yearnum[1]+0.25*quarternum
gen timesq = time^2





twoway (tsline dhp) (tsline demp4, yaxis(2)) if bigmsa<=7 & year>=1990 | msa=="SFE" & year>=1990| msa=="NEO" & year>=1990, by(msa) xlabel(#3, labsize(small)) ylabel(#2, axis(2) labsize(small)) ylabel(#3, axis(1) labsize(small)) 

*twoway (tsline dhp) (tsline dpinc, yaxis(2)) if bigmsa<=7 & year>=1990 | msa=="SFE" & year>=1990| msa=="NEO" & year>=1990, by(msa) xlabel(#3, labsize(small)) ylabel(#2, axis(2) labsize(small)) ylabel(#3, axis(1) labsize(small)) 

* twoway (tsline dhp) (tsline g_polk2_sa_index, yaxis(2)) if bigmsa<=7 & year>=1990 | msa=="SFE" & year>=1990| msa=="NEO" & year>=1990, by(msa) xlabel(#3, labsize(small)) ylabel(#2, axis(2) labsize(small)) ylabel(#3, axis(1) labsize(small)) 






************************************************************
* Option 1: House Prices separate positive and negative changes
************************************************************

bysort msa_code (year): gen dhppos1=max(dhp,0) if dhp!=.
bysort msa_code (year): gen dhpneg1=min(dhp,0) if dhp!=.
/**/


************************************************************
* Option 2: House Prices separate values above and below linear trend by msa_code
************************************************************

gen loghpreal=log(hpreal)
gen hpresid=.
levelsof msa_code, local(groups)

foreach a of local groups {
	quietly reg loghpreal time if msa_code==`a' & yearnum>1975
	tempvar d
	quietly predict `d', residuals
	quietly replace hpresid=`d' if msa_code==`a'
}

bysort msa_code (year): gen dhppos2=dhp if dhp!=.
bysort msa_code (year): gen dhpneg2=dhp if dhp!=.
replace dhppos2=0 if hpresid<0 & hpresid!=.
replace dhpneg2=0 if hpresid>=0 & hpresid!=.

* xtline hpresid if bigmsa<=16, xlabel(#3, labsize(small)) ylabel(#3, labsize(small))  mcolor(black) 


************************************************************
* Option 3: 
************************************************************


bysort msa_code (year): gen cv=log(hpreal)-log(pincx)
bysort msa_code (year): gen dhptrend=100*(cv-cv[_n-3])

bysort msa_code (year): gen dhppos3=dhp if dhp!=.
bysort msa_code (year): gen dhpneg3=dhp if dhp!=.
replace dhppos3=0 if dhptrend<0 
replace dhpneg3=0 if dhptrend>=0 

* xtline dhppos3 dhpneg3 if bigmsa<=16, xlabel(#3, labsize(small)) ylabel(#3, labsize(small))  mcolor(black) 













//Percent of MSAs with positive house price variables
bysort year: egen pos_count1 = sum(dhppos1!=0 & dhppos1!=.)
bysort year: egen neg_count1 = sum(dhpneg1!=0 & dhpneg1!=.)
gen percent_pos1 = 100*pos_count1/(pos_count1+neg_count1)

bysort year: egen pos_count2 = sum(dhppos2!=0 & dhppos2!=.)
bysort year: egen neg_count2 = sum(dhpneg2!=0 & dhpneg2!=.)
gen percent_pos2 = 100*pos_count2/(pos_count2+neg_count2)

bysort year: egen pos_count3 = sum(dhppos3!=0 & dhppos3!=.)
bysort year: egen neg_count3 = sum(dhpneg3!=0 & dhpneg3!=.)
gen percent_pos3 = 100*pos_count3/(pos_count3+neg_count3)


sort msa_code year


label variable percent_pos1 "%, House Price inflation"
label variable percent_pos2 "%, Above trend"
label variable percent_pos3 "%, Above trend growth"


 twoway (tsline percent_pos1 percent_pos2 percent_pos3, lwidth(medthick)) if bigmsa==1, ytitle( . )  title(Percentage of U.S. MSA with Housing Boom)  subtitle( ) caption( ) note( ) legend() 








bysort msa_code (year): gen dhplagpos1=dhppos1[_n-$k]
bysort msa_code (year): gen dhplagneg1=dhpneg1[_n-$k]
bysort msa_code (year): gen dhplagpos2=dhppos2[_n-$k]
bysort msa_code (year): gen dhplagneg2=dhpneg2[_n-$k]
bysort msa_code (year): gen dhplagpos3=dhppos3[_n-$k]
bysort msa_code (year): gen dhplagneg3=dhpneg3[_n-$k]


bysort msa_code (year): gen y=log(polk1_sa_index)
bysort msa_code (year): gen dy=g_polk1_sa_index 
bysort msa_code (year): gen dylag=dy[_n-$k]
bysort msa_code (year): gen hp=log(hpreal)





* keep if yearnum>2001

local y_start = 1970
local y_end = 2011
forvalues yy = `y_start'(1)`y_end' {
	gen y_`yy' = 0
	replace y_`yy' = 1 if year==`yy'
	local ydummies = "`ydummies' y_`yy'" 
	}




sort msa_code year
bysort msa_code (year): egen meandy=mean(dy) 
sort msa_code year
bysort msa_code (year): egen meandhp=mean(dhp) 
sort msa_code year
bysort msa_code (year): gen withindy=dy-meandy
sort msa_code year
bysort msa_code (year): gen withindhp=dhp-meandhp









foreach curr_lhs of varlist demp4  {

* foreach ii in 1 1001 2 2001 3 3001 {
 foreach ii in 2 2001 {

if `ii'==1 { 
local dhplagpos = "dhplagpos1"
local dhplagneg = "dhplagneg1" 
}
if `ii'==1001 { 
local dhplagpos = "dhplag"
local dhplagneg = "dhplagneg1" 
}
if `ii'==2 { 
local dhplagpos = "dhplagpos2"
local dhplagneg = "dhplagneg2" 
}
if `ii'==2001 { 
local dhplagpos = "dhplag"
local dhplagneg = "dhplagneg2" 
}
if `ii'==3 { 
local dhplagpos = "dhplagpos3"
local dhplagneg = "dhplagneg3" 
}
if `ii'==3001 { 
local dhplagpos = "dhplag"
local dhplagneg = "dhplagneg3" 
}


bysort msa_code (year): gen dy2=`curr_lhs' 

bysort msa_code (year): gen dy2lag=dy2[_n-$k]





#delimit ;
xtreg dy2 dhplag if tin(1991,2011) , fe robust;
#delimit cr
estimates store m1

#delimit ;
xtreg dy2 `dhplagpos' `dhplagneg' if tin(1991,2011), fe robust;
#delimit cr
estimates store m2

#delimit ;
xtreg dy2 `dhplagpos' `dhplagneg' y_1991-y_2010 if tin(1991,2011), fe robust;
#delimit cr
estimates store m3

#delimit ;
xtreg dy2 `dhplagpos' `dhplagneg' dy2lag y_1991-y_2010 if tin(1991,2011), fe robust;
#delimit cr
estimates store m4

#delimit ;
xtreg dy2 `dhplagpos' `dhplagneg' dy2lag dpinclag y_1991-y_2010 if tin(`tin1',`tin2'), fe robust;
#delimit cr
estimates store m5


// To get p-values of test need to combine regs100 with pvalues of pvals101

if `ii'<100 { 
estout m1 m2 m3 m4 m5 using "output/Table5_msa_`curr_lhs'_`ii'.csv", ///
drop(*y_*) cells(b(s fmt(%8.3f)) se(par)) stats(N N_g r2_o r2_w r2_b) delimiter(",") ///
starlevel(* 0.10 ** 0.05 *** 0.01) replace
}
if `ii'>=101 { 
estout m1 m2 m3 m4 m5 using "output/Table5_msa_pval_`curr_lhs'_`ii'.csv", ///
keep(*dhplagneg*) cells(b(s fmt(%8.4f)) p) delimiter(",") starlevel(* 0.10 ** 0.05 *** 0.01) replace
}

// //Variable summary by msa
// quietly estpost tabstat dy, by(msa_code) statistics(mean sd min max) columns(statistics)
// estimates store s
// estout s using "msa_table_`curr_lhs'.csv", ///
// cells("mean(fmt(%8.1f)) sd min max") del(",") replace


drop dy2* 

}

}
















* keep if year==2003 | year==2007 | year==2011 
keep if year==2002 | year==2006 | year==2010 


bysort msa_code (year): egen peso=mean(poptotal)

gen t=1 if year==2002
replace t=2 if year==2006
replace t=3 if year==2010

tsset msa_code t
sort msa_code t

bysort msa_code (t): gen dq=100*(hpreal/hpreal[_n-1]-1)
bysort msa_code (t): gen dcar=100*polk2_sa_index/polk2_sa_index[_n-1]-100
bysort msa_code (t): gen dinc=100*(pincx/pincx[_n-1]-1)




* NO INCOME
regress dq elasticity if year==2006 
estimates store m1

ivregress 2sls dcar (dq=elasticity) if year==2006
estimates store m2

regress dq elasticity if year==2010 
estimates store m3

ivregress 2sls dcar (dq=elasticity) if year==2010 
estimates store m4

ivregress 2sls dcar (dq=elasticity) if year==2006 & dq>0 
estimates store ss1

ivregress 2sls dcar (dq=elasticity) if year==2010 & dq<0 
estimates store ss2

estout m1 m2 m3 m4 ss1 ss2 using "output/Table6_msa.csv", ///
cells(b(s fmt(%8.2f)) se(par)) stats(N r2) delimiter(",") starlevel(* 0.10 ** 0.05 *** 0.01) replace



* NO INCOME

ivregress 2sls dcar elasticity if year==2006 
estimates store m2

ivregress 2sls dcar elasticity if year==2010 
estimates store m4


estout m2 m4 using "output/Table6_msaregressions_testoverident.csv", ///
cells(b(s fmt(%8.2f)) se(par)) stats(N r2) delimiter(",") starlevel(* 0.10 ** 0.05 *** 0.01) replace




//
//
// * INCOME
// regress dq elasticity dinc if year==2006 
// estimates store m1
//
// ivregress 2sls dcar dinc (dq=elasticity) if year==2006 
// estimates store m2
//
// regress dq elasticity dinc if year==2010 
// estimates store m3
//
// ivregress 2sls dcar dinc (dq=elasticity) if year==2010 
// estimates store m4
//
// ivregress 2sls dcar dinc (dq=elasticity) if year==2006 & dq>0 
// estimates store ss1
//
// ivregress 2sls dcar dinc (dq=elasticity) if year==2010 & dq<0 
// estimates store ss2
//
// estout m1 m2 m3 m4 ss1 ss2 using "msaregressions_inc.csv", ///
// cells(b(s fmt(%8.2f)) se(par)) stats(N r2) delimiter(",") starlevel(* 0.10 ** 0.05 *** 0.01) replace
//
//





ivregress 2sls dcar dinc (dq=elasticity) if year==2010, first  
estimates store m1














/*

* Only for charts drop this city which has gigantic housing supply elasticity
drop if msa=="PIN"




/// Two ways of doing graph: option 1 nets income out first. A bit too brainy and screws axis
* Net income out first
regress dq dinc if year==2006
predict dq1, resid
regress dq dinc if year==2010
predict dq2, resid

regress dcar dinc if year==2006
predict dcar1, resid
regress dcar dinc if year==2010
predict dcar2, resid

regress dq1 elasticity if year==2006 
predict dqhat2006
regress dq2 elasticity if year==2010 
predict dqhat2010


scatter dq1 elasticity if year==2006,  mlabel(geography) mlabsize(tiny) mcolor(green) name(top1)
scatter dq2 elasticity if year==2010,  mlabel(geography) mlabsize(tiny) mcolor(green) name(bottom1)
graph combine top1 bottom1, col(1)


regress dcar1 dqhat2006 if t==2
predict dcarhat2006
regress dcar2 dqhat2010 if t==3
predict dcarhat2010


#delimit ; 
scatter   dcar1 dqhat2006 if t==2 & bigmsa<1000,  mlabel(msa) mcolor(green) 
||scatter dcar2 dqhat2010 if t==3 & bigmsa<1000,  mlabel(msa) mcolor(red) 
|| line dcarhat2006 dqhat2006, clcolor(green) sort graphregion(color(white))
|| line dcarhat2010 dqhat2010, clcolor(red) sort graphregion(color(white))
title(House Prices and Auto Registrations - MSA)
ytitle(% Change Car Registrations)
xtitle(% Change House Prices)
name(graph1, replace) 
legend(cols(3)) legend(label(1 "2002-2006")  label(2 "2006-2010") label(3 "Fitted 2002-06") label(4 "Fitted 2006-10"));
#delimit cr




/// option 2 does NOT net income out first. 
* Net income out first

regress dq elasticity if year==2006 
predict dqhat2006a
regress dq elasticity if year==2010 
predict dqhat2010a


scatter dq elasticity if year==2006,  mlabel(geography) mlabsize(tiny) mcolor(green) name(top2)
scatter dq elasticity if year==2010,  mlabel(geography) mlabsize(tiny) mcolor(green) name(bottom2)
graph combine top2 bottom2, col(1)


regress dcar dqhat2006 if t==2
predict dcarhat2006a
regress dcar dqhat2010 if t==3
predict dcarhat2010a


#delimit ; 
scatter   dcar dqhat2006a if t==2 & bigmsa<1000,  mlabel(msa) mcolor(green) 
||scatter dcar dqhat2010a if t==3 & bigmsa<1000,  mlabel(msa) mcolor(red) 
|| line dcarhat2006a dqhat2006a, clcolor(green) sort graphregion(color(white))
|| line dcarhat2010a dqhat2010a, clcolor(red) sort graphregion(color(white))
title(House Prices and Auto Registrations - MSA)
ytitle(% Change Car Registrations)
xtitle(% Change House Prices)
name(graph2, replace) 
legend(cols(3)) legend(label(1 "2002-2006")  label(2 "2006-2010") label(3 "Fitted 2002-06") label(4 "Fitted 2006-10"));
#delimit cr


















